package ovh.mxg.cubetp;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.command.ConsoleCommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.java.JavaPlugin;

import java.sql.*;
import java.text.MessageFormat;

public class SQL {
    public static Connection con;

    static ConsoleCommandSender console = Bukkit.getConsoleSender();

    // connect
    public static void connect() {
        if (!isConnected()) {
            try {
                con = DriverManager.getConnection("jdbc:mysql://" + CubeTP.host + ":" + CubeTP.port + "/" + CubeTP.database, CubeTP.username, CubeTP.password);
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    // disconnect
    public static void disconnect() {
        if (isConnected()) {
            try {
                con.close();
                console.sendMessage("\247c[\2476Minepedia-System\247c]\247bMySQL-Verbindung wurde geschlossen!");
            } catch (SQLException e) {
                e.printStackTrace();
            }
        }
    }

    // isConnected
    public static boolean isConnected() {
        return (con == null ? false : true);
    }

    // getConnection
    public static Connection getConnection() {
        return con;
    }

    public static void AddDeath(Player player, Location loc) throws SQLException {
        String uuid = player.getUniqueId().toString();
        connect();
        PreparedStatement ps = getConnection().prepareStatement("INSERT IGNORE INTO cubedeath (uuid,x,y,z) VALUES (?,?,?,?)");
        ps.setString(1, uuid);
        ps.setDouble(2, loc.getBlockX());
        ps.setDouble(3, loc.getBlockY());
        ps.setDouble(4, loc.getBlockZ());
        ps.executeUpdate();
    }

    public static boolean CheckDeathExists(Player player) throws SQLException {
        String uuid = player.getUniqueId().toString();
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubedeath WHERE uuid = ?");
        ps.setString(1, uuid);
        ResultSet rs = ps.executeQuery();
        return rs.next();
    }

    public static Location GenDeathLoc(Player player) throws SQLException {
        String uuid = player.getUniqueId().toString();
        World world = player.getWorld();
        Location dLoc = null;
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubedeath WHERE uuid = ?");
        ps.setString(1, uuid);
        ResultSet rs = ps.executeQuery();
        if(rs.next()){
            dLoc = new Location(world, rs.getDouble("x"), rs.getDouble("Y"), rs.getDouble("Z"));
            return dLoc;
        }
        return dLoc;
    }

    public static String GenDeathLore(Player player) throws SQLException {
        String uuid = player.getUniqueId().toString();
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubedeath WHERE uuid = ?");
        ps.setString(1, uuid);
        ResultSet rs = ps.executeQuery();
        if(rs.next()){
            return MessageFormat.format("x{0} y{1} z{2}", rs.getDouble("x"), rs.getDouble("Y"), rs.getDouble("Z"));
        }
        return "";
    }

    public static void DeleteDeathByUUID(Player player) throws SQLException {
        String uuid = player.getUniqueId().toString();
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("DELETE FROM cubedeath WHERE uuid = ?");
        ps.setString(1, uuid);
        ps.executeUpdate();
    }

    public static void AddCube(String name, double x, double y, double z, String uuid) throws SQLException {
        connect();
        PreparedStatement ps = getConnection().prepareStatement("INSERT IGNORE INTO cubetp (name,x,y,z,uuid) VALUES (?,?,?,?,?)");
        ps.setString(1, name);
        ps.setDouble(2, x);
        ps.setDouble(3, y);
        ps.setDouble(4, z);
        if(uuid != null){
            ps.setString(5, uuid);
        } else {
            ps.setString(5, null);
        }
        ps.executeUpdate();
    }

    public static boolean CheckCubeNameExists(String name) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE name = ?");
        ps.setString(1, name);
        ResultSet rs = ps.executeQuery();
        return rs.next();
    }

    public static void DeleteCubeByName(String name) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("DELETE FROM cubetp WHERE name = ?");
        ps.setString(1, name);
        ps.executeUpdate();
    }

    public static boolean CheckCubeByLocation(double x, double y, double z) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE x = ? AND y = ? AND z = ?");
        ps.setDouble(1, x);
        ps.setDouble(2, y);
        ps.setDouble(3, z);
        ResultSet rs = ps.executeQuery();
        return rs.next();
    }

    public static String GetCubeNameByLocation(double x, double y, double z) throws SQLException {
        SQL.connect();
        PreparedStatement ps = SQL.getConnection().prepareStatement("SELECT * FROM cubetp WHERE x = ? AND y = ? AND z = ?");
        ps.setDouble(1, x);
        ps.setDouble(2, y);
        ps.setDouble(3, z);
        ResultSet rs = ps.executeQuery();
        if(rs.next()){
            return rs.getString("name");
        }
        return null;
    }
}
